with Stringpack, Ada.Calendar;
use Stringpack, Ada.Calendar;
procedure Shared_Demo4 is

   Start_Work, End_Work: Time;
   Anz: Positive := 1_000_000;

   protected Shared_N is
      procedure Incr_N;
      procedure Decr_N;
      function Give_N return Integer;
   private
      N: Integer := 0;
   end Shared_N;

   protected body Shared_N is
      procedure Incr_N is
      begin
         N := N+1;
      end Incr_N;

      procedure Decr_N is
      begin
         N := N-1;
      end Decr_N;

      function Give_N return Integer is
      begin
         return N;
      end Give_N;
   end Shared_N;

   task Up is
      entry Start;
      entry Finish;
   end Up;

   task body Up is
   begin
      accept Start;
      for I in 1..Anz loop
         Shared_N.Incr_N;
      end loop;
      accept Finish;
   end Up;

   task Down is
      entry Start;
      entry Finish;
   end Down;

   task body Down is
   begin
      accept Start;
      for I in 1..Anz loop
         Shared_N.Decr_N;
      end loop;
      accept Finish;
   end Down;

begin
   Start_Work := Clock;  --Zeiterfassung
   Up.Start; Down.Start;
   Up.Finish; Down.Finish;
   Print("n= " & Shared_N.Give_N);
   End_Work := Clock;  --Zeiterfassung
   Print("time spent= " & Float(Ada.Calendar."-"(End_Work, Start_Work)));
end Shared_Demo4;

